.include "M16def.inc"


.def Temp 			= r16
.def temp2 			= r17


;Speicheradressen fr die Uhr
.equ	pHZ			= 0x0061	;Stunden Zehner
.equ	pHE			= 0x0062	;Stunden Einer
.equ	pMZ			= 0x0063	;Minuten Zehner
.equ	pME			= 0x0064	;Minuten Einer 
.equ	pSZ			= 0x0065	;Sekunden Zehner
.equ	pSE			= 0x0066	;Sekunden Einer 
.equ	pPZ			= 0x0067	;Zehntel
.equ	pPE			= 0x0068	;Hundertstel

.org 0x00
	rjmp Reset
.org OVF0addr
	rjmp OVF0

.include "OLED_Mod.asm"

OVF0:		;Wird bei 6,5536MHz genau alle 10ms ausgefhrt
	push Temp
	in Temp,SREG
	push Temp
	push Temp2

	lds Temp,pPE		;Hundertstel laden
	inc Temp			;Hundertstel um 1 erhhen
	clr Temp2			;Temp2 auf 0 setzen
	cpi Temp,10			;Zehn Hundertstel erreicht?
	brne PC+3			;Wenn nicht: die nchsten 2 Zeilen berspringen
		clr Temp		;Wenn Ja: Hndertstel auf 0
		ldi Temp2,1		;Temp2 mit 1 laden um es zu den Zehnteln zu addieren
	sts pPE,Temp		;Hundertstel speichern
						;und so weiter...
	lds Temp,pPZ
	add Temp,Temp2
	clr Temp2			
	cpi Temp,10
	brne PC+3
		clr Temp
		ldi Temp2,1
	sts pPZ,Temp

	lds Temp,pSE
	add Temp,Temp2
	clr Temp2
	cpi Temp,10
	brne PC+3
		clr Temp
		ldi Temp2,1
	sts pSE,Temp

	lds Temp,pSZ
	add Temp,Temp2
	clr Temp2
	cpi Temp,6
	brne PC+3
		clr Temp
		ldi Temp2,1
	sts pSZ,Temp

	lds Temp,pME
	add Temp,Temp2
	clr Temp2
	cpi Temp,10
	brne PC+3
		clr Temp
		ldi Temp2,1
	sts pME,Temp

	lds Temp,pMZ
	add Temp,Temp2
	clr Temp2
	cpi Temp,6
	brne PC+3
		clr Temp
		ldi Temp2,1
	sts pMZ,Temp

	lds Temp,pHE
	add Temp,Temp2
	clr Temp2
	cpi Temp,10
	brne PC+3
		clr Temp
		ldi Temp2,1
	sts pHE,Temp

	lds Temp,pHZ
	add Temp,Temp2
	clr Temp2
	cpi Temp,2
	brne PC+3
		clr Temp
		ldi Temp2,1
	sts pHZ,Temp

		
			

	pop Temp2
	pop Temp
	out SREG,Temp
	pop Temp
reti

Reset:
	ldi Temp,LOW(RAMEND)
	out SPL,Temp
	ldi Temp,HIGH(RAMEND)
	out SPH,Temp 

	
//Zeit auf 00:00:00:00 setzten
	clr Temp
	sts	pHZ,Temp
	sts	pHE,Temp
	sts	pMZ,Temp
	sts	pME,Temp
	sts	pSZ,Temp
	sts	pSE,Temp
	sts	pPZ,Temp
	sts	pPE,Temp

	ldi Temp,(1<<CS02)	;Timer Setup
	out TCCR0,Temp

	ldi Temp,(1<<TOIE0)	;Timer berlauf-Interupt Einschalten
	out TIMSK,Temp

	rcall OLED_Init		;OLED Einschalten und Lschen

	sei					;Global Interupts zulassen

Main:

	ldi Para0,0				;X
	ldi Para1,2				;Y
	rcall SetFontPos

	ldi	ZL,LOW(t_Text*2)	;Low-Zeiger auf Tabellenanfang
	ldi	ZH,HIGH(t_Text*2)	;High-Zeiger auf Tabellenanfang
	ldi Para0,255			;Rot
	ldi Para1,168			;Grn
	ldi Para2,0				;Blau
	rcall String			;Text Ausgeben

;Stunden Ausgeben
	ldi Para0,15			;Pos X
	ldi Para1,15			;Pos Y
	rcall SetFontPos

	lds Para0,pHZ			;Zehner laden
	ldi Para1,255			;Rot
	ldi Para2,11			;Grn
	ldi Para3,229			;Blau
	rcall ZifferZeichnen	;Zehner zeichnen

	ldi Para0,21			;Pos X
	ldi Para1,15			;Pos Y
	rcall SetFontPos		

	lds Para0,pHE			;Einer laden
	ldi Para1,255			;Rot
	ldi Para2,11			;Grn
	ldi Para3,229			;Blau
	rcall ZifferZeichnen	;Einer Zeichnen
;Doppelpunkt
	ldi Para0,27
	ldi Para1,15
	rcall SetFontPos
	ldi	ZL,LOW(c_3A*2)
	ldi	ZH,HIGH(c_3A*2)
	ldi Para0,255
	ldi Para1,11
	ldi Para2,229
	rcall ZeichneZeichen
;Minuten Ausgeben
	ldi Para0,33
	ldi Para1,15
	rcall SetFontPos

	lds Para0,pMZ
	ldi Para1,255
	ldi Para2,11
	ldi Para3,229
	rcall ZifferZeichnen

	ldi Para0,39
	ldi Para1,15
	rcall SetFontPos

	lds Para0,pME
	ldi Para1,255
	ldi Para2,11
	ldi Para3,229
	rcall ZifferZeichnen
;Doppelpunkt
	ldi Para0,45
	ldi Para1,15
	rcall SetFontPos
	ldi	ZL,LOW(c_3A*2)
	ldi	ZH,HIGH(c_3A*2)
	ldi Para0,255
	ldi Para1,11
	ldi Para2,229
	rcall ZeichneZeichen
;Sekunden Ausgeben
	ldi Para0,51
	ldi Para1,15
	rcall SetFontPos

	lds Para0,pSZ
	ldi Para1,225
	ldi Para2,11
	ldi Para3,229
	rcall ZifferZeichnen

	ldi Para0,57
	ldi Para1,15
	rcall SetFontPos

	lds Para0,pSE
	ldi Para1,255
	ldi Para2,11
	ldi Para3,229
	rcall ZifferZeichnen
;Doppelpunkt
	ldi Para0,63
	ldi Para1,15
	rcall SetFontPos
	ldi	ZL,LOW(c_3A*2)
	ldi	ZH,HIGH(c_3A*2)
	ldi Para0,255
	ldi Para1,11
	ldi Para2,229
	rcall ZeichneZeichen
;Hundertstel ausgeben
	ldi Para0,69
	ldi Para1,15
	rcall SetFontPos

	lds Para0,pPZ
	ldi Para1,255
	ldi Para2,11
	ldi Para3,229
	rcall ZifferZeichnen

	ldi Para0,75
	ldi Para1,15
	rcall SetFontPos

	lds Para0,pPE
	ldi Para1,255
	ldi Para2,11
	ldi Para3,229
	rcall ZifferZeichnen

;Text
	ldi Para0,70			;X
	ldi Para1,40			;Y
	rcall SetFontPos

	ldi	ZL,LOW(t_Text3*2)	;Low-Zeiger auf Tabellenanfang
	ldi	ZH,HIGH(t_Text3*2)	;High-Zeiger auf Tabellenanfang
	ldi Para0,0				;Rot
	ldi Para1,255			;Grn
	ldi Para2,186			;Blau
	rcall String			;Text Ausgeben
;Text
	ldi Para0,6				;X
	ldi Para1,48			;Y
	rcall SetFontPos

	ldi	ZL,LOW(t_Text2*2)	;Low-Zeiger auf Tabellenanfang
	ldi	ZH,HIGH(t_Text2*2)	;High-Zeiger auf Tabellenanfang
	ldi Para0,0				;Rot
	ldi Para1,162			;Grn
	ldi Para2,255			;Blau
	rcall String			;Text Ausgeben

rjmp main

String:
	;Gibt eine Zeichenfolge bis zum "Nullterminierungszeichen" '' aus
	lpm Temp,Z		;Zeichen speichern
	push ZL			;Z zeigt noch auf das Zeichen im String
	push ZH
	ldi	ZL,LOW(c_00*2)	;Zeichentabelle
	ldi	ZH,HIGH(c_00*2)	

	ldi Temp2,6			;Ein Zeichen enthllt 6 Byte
	mul Temp,Temp2		;Deshalb Zeichen*6
	add ZL,r0			;Das Ergebnis zum Anfang der Zeichentabelle addieren
	adc ZH,r1

	rcall ZeichneZeichen	;Z zeigt nun auf das Byte-Muster um RAM was dem Zeichen entspricht. Also wird es jetzt gezeichnet

	pop ZH				;zurch zum String
	pop ZL

	adiw ZL,1			;nchstes Zeichen
	lpm Temp,Z			;laden
	cpi Temp,''		;ist es das "Nullterminierungszeichen?"
	brne String			;Wenn nicht => weiter Ausgeben
ret

SetFontPos:
	push Para0
	push Para1

	ldi Command,OLED_SETCOL
	ldi Para1,95
	rcall OLED_Cntr2P_Out


	ldi Command,OLED_FORMAT
	ldi Para,(1<<OLED_VINC)|(1<<OLED_COMSPLIT)|(1<<OLED_65k)|(1<<OLED_HMIRROR)
	rcall OLED_Cntr1P_Out

	ldi Command,OLED_SETROW
	pop Para0 ;was Para1 war
	push Para0

	pop Para1
	push Para1
	ldi Temp,7
	add Para1,Temp
	rcall OLED_Cntr2P_Out

	pop Para1
	pop Para0

ret

ZeichneZeichen:
	push Temp
	push Temp2
	ldi Temp2,6
	ZeileZeichnen:
	lpm Temp,Z
	push Temp2
	ldi Temp2,8
	loopPix:
		lsl Temp
		brcs Pixel1zeichnen
		;Pixellschen:
		push Para
		ldi Para,0
		rcall OLED_Data_Out
		rcall OLED_Data_Out
		pop Para
		rjmp outPix
		Pixel1zeichnen:
		rcall OLED_RGB24_OUT
	outPix:
	dec Temp2
	brne loopPix
	pop Temp2
	dec Temp2
	breq ZeichenFertsch
	adiw ZL,1
	rjmp ZeileZeichnen
	ZeichenFertsch:
	pop Temp2
	pop Temp
ret

ZifferZeichnen:
push Temp2
	ldi	ZL,LOW(c_0*2)	;Low-Zeiger auf Tabellenanfang
	ldi	ZH,HIGH(c_0*2)	;High-Zeiger auf Tabellenanfang
	clr Temp2
	add ZL,Para0
	adc ZH,Temp2
	add ZL,Para0
	adc ZH,Temp2
	add ZL,Para0
	adc ZH,Temp2
	add ZL,Para0
	adc ZH,Temp2
	add ZL,Para0
	adc ZH,Temp2
	add ZL,Para0
	adc ZH,Temp2
	mov Para0,Para1
	mov Para1,Para2
	mov Para2,Para3
	rcall ZeichneZeichen
pop Temp2
ret


t_Text: .DB "Betriebsstunden:"
t_Text2:.DB "Harry Grnewald"
t_Text3:.DB "von"

;Die Zeichentabelle ist noch nicht komplett!!!!!!!!!!!!!!!!!!!!!!
c_00: 	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_01: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_02: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_03: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_04: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_05: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_06: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_07: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_08: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_09: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_0A: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_0B: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_0C: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_0D: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_0E: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_0F: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_10: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_11: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_12: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_13: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_14: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_15: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_16: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_17: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_18: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_19: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_1A: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_1B: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_1C: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_1D: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_1E: 	.DB 0b00000000,0b00000110,0b00000110,0b00000000,0b00000000,0b00000000
c_1F: 	.DB 0b00000000,0b00000110,0b00000110,0b00000000,0b00000000,0b00000000
c_20:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000 ;Leer und irgentwie auch 
c_21: 	.DB 0b00000000,0b00000000,0b11111010,0b00000000,0b00000000,0b00000000 ;!
c_22: 	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000 ;"
c_23: 	.DB 0b00101000,0b11111110,0b00101000,0b11111110,0b00101000,0b00000000 ;#
c_24: 	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_25: 	.DB 0b11000100,0b11001000,0b00010000,0b00100110,0b01000110,0b00000000 ;%
c_26: 	.DB 0b01101100,0b10010010,0b10101010,0b01000100,0b00001010,0b00000000 ;&
c_27: 	.DB 0b00000000,0b10100000,0b11000000,0b00000000,0b00000000,0b00000000 ;'
c_28: 	.DB 0b00000000,0b00111000,0b01000100,0b10000010,0b00000000,0b00000000 ;(
c_29: 	.DB 0b00000000,0b10000010,0b01000100,0b00111000,0b00000000,0b00000000 ;)
c_2A: 	.DB 0b00000000,0b11000000,0b00000000,0b00100000,0b00000000,0b00000000 ;*
c_2B: 	.DB 0b00010000,0b00010000,0b01111100,0b00010000,0b00010000,0b00000000 ;+
c_2C: 	.DB 0b00000000,0b00001010,0b00001100,0b00000000,0b00000000,0b00000000 ;,
c_2D: 	.DB 0b00010000,0b00010000,0b00010000,0b00010000,0b00010000,0b00000000 ;-
c_2E: 	.DB 0b00000000,0b00000110,0b00000110,0b00000000,0b00000000,0b00000000 ;.
c_2F: 	.DB 0b00000100,0b00001000,0b00010000,0b00100000,0b01000000,0b00000000 ;/
c_0: 	.DB 0b01111100,0b10001010,0b10010010,0b10100010,0b01111100,0b00000000
c_1: 	.DB 0b00000000,0b01000010,0b11111110,0b00000010,0b00000000,0b00000000
c_2: 	.DB 0b01000010,0b10000110,0b10001010,0b10010010,0b01100010,0b00000000
c_3: 	.DB 0b10000100,0b10000010,0b10100010,0b11010010,0b10001100,0b00000000
c_4: 	.DB 0b00011000,0b00101000,0b01001000,0b11111110,0b00001000,0b00000000
c_5: 	.DB 0b11100100,0b10100010,0b10100010,0b10100010,0b10011100,0b00000000
c_6: 	.DB 0b00111100,0b01010010,0b10010010,0b10010010,0b00001100,0b00000000
c_7: 	.DB 0b10000000,0b10001110,0b10010000,0b10100000,0b11000000,0b00000000
c_8: 	.DB 0b01101100,0b10010010,0b10010010,0b10010010,0b01101100,0b00000000
c_9: 	.DB 0b01100000,0b10010010,0b10010010,0b10010100,0b01111000,0b00000000
c_3A: 	.DB 0b00000000,0b01101100,0b01101100,0b00000000,0b00000000,0b00000000 ;:
c_3B: 	.DB 0b00000000,0b01101010,0b01101100,0b00000000,0b00000000,0b00000000 ;;
c_3C: 	.DB 0b00010000,0b00101000,0b01000100,0b10000010,0b00000000,0b00000000 ;<
c_3D: 	.DB 0b00101000,0b00101000,0b00101000,0b00101000,0b00101000,0b00000000 ;=
c_3E: 	.DB 0b00000000,0b10000010,0b01000100,0b00101000,0b00010000,0b00000000 ;>
c_3F: 	.DB 0b01000000,0b10000000,0b10001010,0b10010000,0b01100000,0b00000000 ;?
c_40: 	.DB 0b00000000,0b00000000,0b00000000,0b00010000,0b00000000,0b00000000
c_A: 	.DB 0b01111110,0b10001000,0b10001000,0b10001000,0b01111110,0b00000000
c_B: 	.DB 0b11111110,0b10010010,0b10010010,0b10010010,0b01101100,0b00000000
c_C: 	.DB 0b01111100,0b10000010,0b10000010,0b10000010,0b01000100,0b00000000
c_D: 	.DB 0b11111110,0b10000010,0b10000010,0b01000100,0b00111000,0b00000000
c_E: 	.DB 0b11111110,0b10010010,0b10010010,0b10010010,0b10000010,0b00000000
c_F: 	.DB 0b11111110,0b10010000,0b10010000,0b10010000,0b10000000,0b00000000
c_G: 	.DB 0b01111100,0b10000010,0b10010010,0b10010010,0b01011110,0b00000000
c_H: 	.DB 0b11111110,0b00010000,0b00010000,0b00010000,0b11111110,0b00000000
c_I: 	.DB 0b00000000,0b10000010,0b11111110,0b10000010,0b00000000,0b00000000
c_J: 	.DB 0b00000100,0b00000010,0b10000010,0b11111100,0b10000000,0b00000000
c_K: 	.DB 0b11111110,0b00010000,0b00101000,0b01000100,0b10000010,0b00000000
c_L: 	.DB 0b11111110,0b00000010,0b00000010,0b00000010,0b00000010,0b00000000
c_M: 	.DB 0b11111110,0b01000000,0b00110000,0b01000000,0b11111110,0b00000000
c_N: 	.DB 0b11111110,0b00100000,0b00010000,0b00001000,0b11111110,0b00000000
c_O: 	.DB 0b01111100,0b10000010,0b10000010,0b10000010,0b01111100,0b00000000
c_P: 	.DB 0b11111110,0b10010000,0b10010000,0b10010000,0b01100000,0b00000000
c_Q: 	.DB 0b00000000,0b00100000,0b00000000,0b00000000,0b00000000,0b00000000
c_R: 	.DB 0b11111110,0b10010000,0b10011000,0b10010100,0b01100010,0b00000000
c_S: 	.DB 0b01100010,0b10010010,0b10010010,0b10010010,0b10001100,0b00000000
c_T: 	.DB 0b10000000,0b10000000,0b11111110,0b10000000,0b10000000,0b00000000
c_U: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_V: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_W: 	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_X: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_Y: 	.DB 0b11100000,0b00010000,0b00001110,0b00010000,0b11100000,0b00000000
c_Z: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_5B: 	.DB 0b00000000,0b11111111,0b10000001,0b10000001,0b00000000,0b00000000 ;[
c_5C: 	.DB 0b01000000,0b00100000,0b00010000,0b00001000,0b00000100,0b00000000 ;\
c_5D: 	.DB 0b00000000,0b10000001,0b10000001,0b11111111,0b00000000,0b00000000 ;]
c_5E: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_5F: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_60: 	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c__a: 	.DB 0b00000100,0b00101010,0b00101010,0b00101010,0b00011110,0b00000000
c__b:	.DB 0b11111110,0b00010010,0b00100010,0b00100010,0b00011100,0b00000000
c__c:	.DB 0b00011100,0b00100010,0b00100010,0b00100010,0b00010100,0b00000000
c__d:	.DB 0b00011100,0b00100010,0b00100010,0b00010010,0b11111110,0b00000000
c__e:	.DB 0b00011100,0b00101010,0b00101010,0b00101010,0b00011000,0b00000000
c__f:	.DB 0b00010000,0b01111110,0b10010000,0b10000000,0b01000000,0b00000000
c__g:	.DB 0b00011000,0b00100101,0b00100101,0b00100101,0b00111110,0b00000000
c__h:	.DB 0b11111110,0b00010000,0b00100000,0b00100000,0b00011110,0b00000000
c__i:	.DB 0b00000000,0b00100010,0b10111110,0b00000010,0b00000000,0b00000000
c__j:	.DB 0b00000100,0b00000010,0b00100010,0b10111100,0b00000000,0b00000000
c__k:	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c__l:	.DB 0b00000000,0b10000010,0b11111110,0b00000010,0b00000000,0b00000000
c__m:	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c__n:	.DB 0b00111110,0b00010000,0b00100000,0b00100000,0b00011110,0b00000000
c__o:	.DB 0b00011100,0b00100010,0b00100010,0b00100010,0b00011100,0b00000000
c__p:	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c__q:	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c__r:	.DB 0b00111110,0b00010000,0b00100000,0b00100000,0b00010000,0b00000000
c__s:	.DB 0b00010010,0b00101010,0b00101010,0b00101010,0b00000100,0b00000000
c__t:	.DB 0b00100000,0b11111100,0b00100010,0b00000010,0b00000100,0b00000000
c__u:	.DB 0b00111100,0b00000010,0b00000010,0b00000100,0b00111110,0b00000000
c__v:	.DB 0b00110000,0b00001100,0b00000010,0b00001100,0b00110000,0b00000000
c__w:	.DB 0b00111100,0b00000010,0b00001100,0b00000010,0b00111100,0b00000000
c__x:	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c__y:	.DB 0b00111000,0b00000101,0b00000101,0b00000101,0b00111110,0b00000000
c__z:	.DB 0b00100010,0b00100110,0b00101010,0b00110010,0b00100010,0b00000000
c_7B:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000 
c_7C:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_7D:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_7E:	.DB 0b00111100,0b10000010,0b00000010,0b10000010,0b00111110,0b00000000 ;
c_7F:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_80:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_81:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_82:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_83:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_84:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_85:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_86:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_87:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_88:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_89:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_8A:	.DB 0b11111110,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_8B:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_8C:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_8D:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_8E:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_8F:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_90:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_91:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_92:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_93:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_94:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_95:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_96:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_97:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_98:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_99:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_9A:	.DB 0b11110000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_9B:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_9C:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_9D:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_9E:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_9F:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_A0:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_A1:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_A2:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_A3:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_A4:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_A5:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_A6:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_A7:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_A8:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_A9:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_AA:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_AB:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_AC:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_AD:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_AE:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_AF:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_B0:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_B1:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_B2:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_B3:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_B4:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_B5:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_B6:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_B7:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_B8:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_B9:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_BA:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_BB:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_BC:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_BD:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_BE:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_BF:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_C0:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_C1:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_C2:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_C3:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_C4:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_C5:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_C6:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_C7:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_C8:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_C9:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_CA:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_CB:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_CC:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_CD:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_CE:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_CF:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_D0:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_D1:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_D2:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_D3:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_D4:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_D5:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_D6:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_D7:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_D8:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_D9:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_DA:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_DB:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_DC:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_DD:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_DE:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_DF:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_E0:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_E1:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_E2:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_E3:	.DB 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_E4:	.DB 0b00000100,0b10101010,0b00101010,0b10101010,0b00011110,0b00000000 ;
c_E5:	.DB 0b10000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_E6:	.DB 0b01000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_E7:	.DB 0b00100000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_E8:	.DB 0b00010000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_E9:	.DB 0b00001000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_EA:	.DB 0b00000100,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_EB:	.DB 0b00000010,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_EC:	.DB 0b00000001,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
c_ED:	.DB 0b00000000,0b10000000,0b00000000,0b00000000,0b00000000,0b00000000
c_EE:	.DB 0b00000000,0b01000000,0b00000000,0b00000000,0b00000000,0b00000000
c_EF:	.DB 0b00000000,0b00100000,0b00000000,0b00000000,0b00000000,0b00000000
c_F0:	.DB 0b00000000,0b00010000,0b00000000,0b00000000,0b00000000,0b00000000
c_F1:	.DB 0b00000000,0b00001000,0b00000000,0b00000000,0b00000000,0b00000000
c_F2:	.DB 0b00000000,0b00000100,0b00000000,0b00000000,0b00000000,0b00000000
c_F3:	.DB 0b00000000,0b00000010,0b00000000,0b00000000,0b00000000,0b00000000
c_F4:	.DB 0b00000000,0b00000001,0b00000000,0b00000000,0b00000000,0b00000000
c_F5:	.DB 0b00000000,0b00000000,0b10000000,0b00000000,0b00000000,0b00000000
c_F6:	.DB 0b00011100,0b10100010,0b00100010,0b10100010,0b00011100,0b00000000
c_F7:	.DB 0b00000000,0b00000000,0b00100000,0b00000000,0b00000000,0b00000000
c_F8:	.DB 0b00000000,0b00000000,0b00010000,0b00000000,0b00000000,0b00000000
c_F9:	.DB 0b00000000,0b00000000,0b00001000,0b00000000,0b00000000,0b00000000
c_FA:	.DB 0b00000000,0b00000000,0b00000100,0b00000000,0b00000000,0b00000000
c_FB:	.DB 0b00000000,0b00000000,0b00000010,0b00000000,0b00000000,0b00000000
c_FC:	.DB 0b00111100,0b10000010,0b00000010,0b10000100,0b00111110,0b00000000 ;
c_FD:	.DB 0b00000000,0b00000000,0b00000001,0b00000000,0b00000000,0b00000000
c_FE:	.DB 0b00000000,0b00000000,0b00000000,0b10000000,0b00000000,0b00000000
c_FF:	.DB 0b00000000,0b00000000,0b00000000,0b00100000,0b00000000,0b00000000


c16_00: .DB 0b11111111,0b11111111,0b10000000,0b00000001,0b10000000,0b00000001,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b10000000,0b00000001,0b10000000,0b00000001,0b11111111,0b11111111
