.def Command		= r18
.def Para			= r19
.def Para0			= r19
.def Para1			= r20
.def Para2			= r21
.def Para3			= r22
.def Para4			= r23
.def Para5			= r24
.def Para6			= r25
.def Para7			= r26
.def Para8			= r27
.def Para9			= r28


.equ OLED_DDR_Cntr		= DDRB
.equ OLED_Cntr			= PORTB		;PortB ist der Steuer-Port
.equ OLED_E				= PB4		;This pin is MCU interface input. When interfacing to a 6800-series microprocessor, this pin will be used as the Enable (E) signal. Read/write operation is initiated when this pin is pulled high and the chip is selected.
.equ OLED_RD#			= PB4		;When connecting to an 8080-microprocessor, this pin receives the Read (RD#) signal. Data read operation is initiated when this pin is pulled low and the chip is selected.
.equ OLED_RW			= PB3		;This pin is MCU interface input. When interfacing to a 6800-series microprocessor, this pin will be used as Read/Write (R/W) selection input. Read mode will be carried out when this pin is pulled high and write mode when low.
.equ OLED_WR#			= PB3		;When 8080 interface mode is selected, this pin will be the Write (WR#) input. Data write operation is initiated when this pin is pulled low and the chip is selected.
.equ OLED_DC			= PB2		;This pin is Data/Command control pin. When the pin is pulled high, the data at D7-D0 is treated as display data. When the pin is pulled low, the data at D7-D0 will be transferred to the command register.
.equ OLED_RES#			= PB1		;This pin is reset signal input. When the pin is low, initialization of the chip is executed.
.equ OLED_CS#			= PB0		;This pin is the chip select input. The chip is enabled for MCU communication only when CS# is pulled low.
.equ OLED_DDR_Data		= DDRD
.equ OLED_Data			= PORTD		;PortD ist Daten-Port
.equ OLED_DataIn		= PIND

.equ OLED_SETCOL		= 0b00010101

.equ OLED_SETROW		= 0b01110101

.equ OLED_CURRENT		= 0b10000111

.equ OLED_NORMAL		= 0b10100100
.equ OLED_WHITE			= 0b10100101
.equ OLED_CLEARPIX		= 0b10100110
.equ OLED_INVERSE		= 0b10100111

.equ OLED_MASTER		= 0b10101101
	;Grundwert			= 0b10001xxx
	.equ OLED_BOOSTER	= 0
	.equ OLED_VCOMH		= 1
	.equ OLED_VP		= 2 

.equ OLED_OFF			= 0b10100111
.equ OLED_ON			= 0b10101111

.equ OLED_CLOCKS		= 0b10110011


.equ OLED_FORMAT		= 0b10100000
	.equ OLED_VINC		= 0
	.equ OLED_VMIRROR	= 1
	.equ OLED_HMIRROR	= 4
	.equ OLED_COMSPLIT	= 5
	.equ OLED_65k		= 6

.equ OLED_CLEAR			= 0b00100101
.equ OLED_FILL			= 0b00100110
	.equ OLED_FILLR		= 0
	.equ OLED_COPYREV	= 4


.equ OLED_RECT			= 0b00100010
.equ OLED_NOP			= 0b11100011


OLED_Cntr_Out:
//8080
/*	cbi OLED_Cntr,OLED_DC
	cbi OLED_Cntr,OLED_CS#
	cbi OLED_Cntr,OLED_WR#
	out OLED_Data,Command
	sbi OLED_Cntr,OLED_WR#
	sbi OLED_Cntr,OLED_CS# */ 
		
//6800
	cbi OLED_Cntr,OLED_DC
	cbi OLED_Cntr,OLED_RW
	sbi OLED_Cntr,OLED_E
	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Command
	sbi OLED_Cntr,OLED_CS#
	cbi OLED_Cntr,OLED_E		
	

ret

OLED_Cntr1P_Out:
//8080
/*	cbi OLED_Cntr,OLED_DC
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Command
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para0
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS */		

//6800
	cbi OLED_Cntr,OLED_DC
	cbi OLED_Cntr,OLED_RW
	sbi OLED_Cntr,OLED_E
	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Command
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para0
	sbi OLED_Cntr,OLED_CS#
	cbi OLED_Cntr,OLED_E
ret

OLED_Cntr2P_Out:
//8080
/*	cbi OLED_Cntr,OLED_DC
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Command
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para0
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para1
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS */		

//6800
	cbi OLED_Cntr,OLED_DC
	cbi OLED_Cntr,OLED_RW
	sbi OLED_Cntr,OLED_E
	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Command
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para0
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para1
	sbi OLED_Cntr,OLED_CS#
	cbi OLED_Cntr,OLED_E
ret


OLED_Cntr4P_Out:
//8080
/*	cbi OLED_Cntr,OLED_DC
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Command
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para0
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para1
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para2
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para3
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS */

//6800
	cbi OLED_Cntr,OLED_DC
	cbi OLED_Cntr,OLED_RW
	sbi OLED_Cntr,OLED_E
	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Command
	sbi OLED_Cntr,OLED_CS#
 
	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para0
	sbi OLED_Cntr,OLED_CS#
 
 	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para1
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para2
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para3
	sbi OLED_Cntr,OLED_CS#
	cbi OLED_Cntr,OLED_E
ret

OLED_Data_Out:
//8080
/*	sbi OLED_Cntr,OLED_DC
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para0
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS */		

//6800
	sbi OLED_Cntr,OLED_DC
	cbi OLED_Cntr,OLED_RW
	sbi OLED_Cntr,OLED_E
	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para
	sbi OLED_Cntr,OLED_CS#
	cbi OLED_Cntr,OLED_E		
ret

OLED_Rechteck:
	push Temp
//8080
/*	cbi OLED_Cntr,OLED_DC
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	ldi Temp,0b00100010	;Rechteck
	out OLED_Data,Temp
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para0
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para1
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para2
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para3
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS

	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para6
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para5
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para4
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para9
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para8
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS
	nop
	cbi OLED_Cntr,OLED_CS
	cbi OLED_Cntr,OLED_WR
	out OLED_Data,Para7
	sbi OLED_Cntr,OLED_WR
	sbi OLED_Cntr,OLED_CS */

//6800
	cbi OLED_Cntr,OLED_DC
	cbi OLED_Cntr,OLED_RW
	sbi OLED_Cntr,OLED_E
	cbi OLED_Cntr,OLED_CS#
	ldi Temp,OLED_RECT			;Rechteck
	out OLED_Data,Temp
	sbi OLED_Cntr,OLED_CS#
 
 	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para0			;Column Address of Start		
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para1			;Row Address of Start
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para2			;Column Address of End
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para3			;Row Address of End
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para6			;Color C of the line
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para5			;Color B of the line
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para4			;Color A of the line
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para9			;Color C of the fill area
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para8			;Color B of the fill area
	sbi OLED_Cntr,OLED_CS#

	cbi OLED_Cntr,OLED_CS#
	out OLED_Data,Para7			;Color A of the fill area
	sbi OLED_Cntr,OLED_CS#
	cbi OLED_Cntr,OLED_E		

	pop Temp
ret

OLED_Init:
	ser Temp
	out OLED_DDR_CNTR,Temp			;Controlregister als Ausgang
	cbi OLED_Cntr,OLED_RES#			;Reset
	out OLED_DDR_Data,temp			;Datenregister als Ausgang
	clr Temp
	out OLED_Data,Temp				

	sbi OLED_Cntr,OLED_CS#			;OLED deselekt
	sbi OLED_Cntr,OLED_RES#			;Reset wieder loslassen

	ldi Command,OLED_ON				;			
	rcall OLED_Cntr_Out

	ldi Command,OLED_FORMAT
	ldi Para,(1<<OLED_COMSPLIT)|(1<<OLED_65k)|(1<<OLED_HMIRROR)
	rcall OLED_Cntr1P_Out

	ldi Command,OLED_SETCOL			;This command specifies column start address and end address of the display data RAM.
	ldi Para0,0
	ldi Para1,95
	rcall OLED_Cntr2P_Out

	ldi Command,OLED_SETROW			;This command specifies row start address and end address of the display data RAM.
	ldi Para0,0
	ldi Para1,63
	rcall OLED_Cntr2P_Out

	ldi Command,OLED_CURRENT		;This command is to control the segment output current by a scale factor.
	ldi Para,0b00001111				;So hell wie mglich
	rcall OLED_Cntr1P_Out

	ldi Command,OLED_MASTER
	ldi Para,0b10001000 | (1<<OLED_BOOSTER) | (1<<OLED_VCOMH) | (1<<OLED_VP)
	rcall OLED_Cntr1P_Out

	ldi Command,OLED_FILL
	ldi Para,1<<OLED_FILLR
	rcall OLED_Cntr1P_Out

	ldi Command,OLED_CLOCKS
	ldi Para,0b11110000				;Maximale Bildwieder
	rcall OLED_Cntr1P_Out

	ldi Command,OLED_CLEAR			;Schirm komplett lschen
	ldi Para0,0
	ldi Para1,0
	ldi Para2,95
	ldi Para3,63
	rcall OLED_Cntr4P_Out

	;Diese Funktion ist das Problem
	rcall OLED_BUSY
	;Und auch dieser Vorschlag fhrt nicht zum Erfolg
	rcall LCD_STATUS_WAIT
	;(Wenn eine Arbeitet ist das vllig ausreichend)


/*	ldi Para0,10
	ldi Para1,10
	ldi Para2,30
	ldi Para3,30
	ldi Para4,255
	ldi Para5,0
	ldi Para6,0
	ldi Para7,0
	ldi Para8,255
	ldi Para9,0
	rcall OLED_Rechteck*/

ret

OLED_BUSY:
;Sollte Warten bis das OLED mit seiner Arbeit fertig ist. z.B. Lschen des Schirms Beendet hat
	push Temp
	clr Temp
	out OLED_DDR_Data,Temp	;Data-Port als Input
	clr Temp
	out OLED_Data,Temp	;Data-Port Pullups ein
	cbi OLED_Cntr,OLED_DC	;D/C auf Controll
	sbi OLED_Cntr,OLED_RW	;RW auf Lesen
	sbi OLED_Cntr,OLED_E	
	cbi OLED_Cntr,OLED_CS#
	OLED_BUSYloop:
	nop						;tACC (Access Time) abwarten, so ca 140ns
	in Temp,OLED_DataIn		;Status auslesen

	sbrc Temp,7				;wenn das "Command lock"-Bit 0 ist ist alles fertig
		rjmp OLED_BUSYloop


	sbi OLED_Cntr,OLED_CS#	;und wieder Aus
	cbi OLED_Cntr,OLED_E	
	ser Temp
	out OLED_DDR_Data,Temp	;Data-Port wieder als Ausgang

	pop Temp
ret





//<Vorschlag von Bernhard>
;#####################################################################
;erzeugt den Enable-Puls
LCD_ENABLE:
  rcall wait_1us    ; kurze Pause
  rcall wait_1us    ; kurze Pause
  sbi OLED_Cntr,OLED_CS#           ; Enable high
  rcall wait_1us    ; kurze Pause
  rcall wait_1us    ; kurze Pause
  rcall wait_1us    ; kurze Pause
  rcall wait_1us    ; kurze Pause
     cbi OLED_Cntr,OLED_CS#           ; Enable low
  rcall wait_1us    ; kurze Pause
  rcall wait_1us    ; kurze Pause
ret
; ####################################################################

wait_1us:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
ret

LCD_STATUS_WAIT:
;Sollte Warten bis das OLED mit seiner Arbeit fertig ist. z.B. Lschen des Schirms Beendet hat
  ; PORT D auf Eingang
  clr temp
  out OLED_DDR_DATA,temp

  ; PULL-UPs off
  clr temp
  out OLED_DATA,temp

  ; LESEMODUS
  sbi OLED_Cntr, OLED_RW  ; RW=>READ   (HIGH)
  cbi OLED_Cntr, OLED_DC  ;
LCD_STATUS_WAIT_w:
  rcall LCD_ENABLE        ; Enable-Routine aufrufen

  ; EINLESEN
  in temp, OLED_DATAIN

  andi temp, 0b10000000
  tst temp
  brne LCD_STATUS_WAIT_w

  ; PORTB auf AUSGANG
  ldi temp, 0b11111111
  out OLED_DDR_DATA,temp
ret
; ####################################################################
//<Ende Vorschlag von Bernhard>






OLED_RGB24_OUT:
//Wandelt Das Format R8G8B8 (24Bit) in R5G6B5 (16Bit) um und gibt es auf dem Daten-Port aus
push Para0	;enthlt R8
push Para1	;enthlt G8
push Para2	;enthlt B8
push Para3	;wird R5G3 enthalten
push Para4	;wird G3B5 enthalten
lsr Para0
lsr Para0
lsr Para0
lsr Para1
lsr Para1
lsr Para2
lsr Para2
lsr Para2

lsr Para0
ror Para3
lsr Para0
ror Para3
lsr Para0
ror Para3
lsr Para0
ror Para3
lsr Para0
ror Para3
lsr Para1
ror Para3
lsr Para1
ror Para3
lsr Para1
ror Para3
lsr Para1
ror Para4
lsr Para1
ror Para4
lsr Para1
ror Para4
lsr Para2
ror Para4
lsr Para2
ror Para4
lsr Para2
ror Para4
lsr Para2
ror Para4
lsr Para2
ror Para4

mov Para0,Para4
rcall OLED_Data_Out
mov Para0,Para3
rcall OLED_Data_Out


pop Para4
pop Para3
pop Para2
pop Para1
pop Para0

ret

